<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class VI_WOOCOMMERCE_THANK_YOU_PAGE_DATA {
	private $params;
	private $default;

	/**
	 * VI_WOOCOMMERCE_THANK_YOU_PAGE_DATA constructor.
	 * Init setting
	 */
	public function __construct() {
		$this->prefix = 'woocommerce-thank-you-page-';
		global $woo_thank_you_page_settings;
		if ( ! $woo_thank_you_page_settings ) {
			$woo_thank_you_page_settings = get_option( 'woo_thank_you_page_params', array() );
		}
		$this->default = array(
			'enable'                                => 0,
			'auto_update_key'                       => '',
			'order_status'                          => array(
				'wc-completed',
				'wc-processing',
				'wc-pending',
				'wc-on-hold',
			),
			'blocks'                                => json_encode(
				array(
					array(
						array(
							'thank_you_message',
							'coupon',
							'order_confirmation',
						),
					),
					array(
						array(
							'customer_information',
						),
						array(
							'order_details',
							'sale_products',
						),
					),
				)
			),
			'text_editor'                           => json_encode( array() ),
			'products'                              => json_encode( array() ),
			'select_order'                          => '',
			'select_template'                       => '0',
			/*order_confirmation*/
			'order_confirmation_bg'                 => '#f7f7f7',
			'order_confirmation_padding'            => 10,
			'order_confirmation_border_radius'      => 0,
			'order_confirmation_border_width'       => 0,
			'order_confirmation_border_style'       => 'dotted',
			'order_confirmation_border_color'       => 'black',
			'order_confirmation_vertical_width'     => 1,
			'order_confirmation_vertical_style'     => 'solid',
			'order_confirmation_vertical_color'     => '#dbdbdb',
			'order_confirmation_horizontal_width'   => 1,
			'order_confirmation_horizontal_style'   => 'solid',
			'order_confirmation_horizontal_color'   => '#dddddd',
			'order_confirmation_header'             => 'Order confirmation',
			'order_confirmation_header_color'       => '',
			'order_confirmation_header_bg_color'    => '',
			'order_confirmation_header_font_size'   => 20,
			'order_confirmation_header_text_align'  => 'left',
			'order_confirmation_title_color'        => '',
			'order_confirmation_title_bg_color'     => '',
			'order_confirmation_title_font_size'    => 16,
			'order_confirmation_title_text_align'   => 'right',
			'order_confirmation_value_color'        => '',
			'order_confirmation_value_bg_color'     => '',
			'order_confirmation_value_font_size'    => 16,
			'order_confirmation_value_text_align'   => 'left',
			'order_confirmation_order_number_title' => 'Order number',
			'order_confirmation_date_title'         => 'Date',
			'order_confirmation_order_total_title'  => 'Total',
			'order_confirmation_email_title'        => 'Email',
			'order_confirmation_payment_title'      => 'Payment method',

			'order_details_color'                     => '',
			'order_details_bg'                        => '',
			'order_details_padding'                   => 0,
			'order_details_border_radius'             => 0,
			'order_details_border_width'              => 0,
			'order_details_border_style'              => 'solid',
			'order_details_border_color'              => '',
			'order_details_font_size'                 => 14,
			'order_details_horizontal_width'          => 1,
			'order_details_horizontal_style'          => 'dotted',
			'order_details_horizontal_color'          => '#ddd',
			'order_details_header'                    => 'Order details',
			'order_details_header_color'              => '',
			'order_details_header_bg_color'           => '',
			'order_details_header_font_size'          => 20,
			'order_details_header_text_align'         => 'left',
			'order_details_product_title_text'        => 'Product',
			'order_details_product_value_text'        => 'Total',
			'order_details_product_image'             => 1,
			'order_details_product_image_width'       => 50,
			'order_details_product_quantity_in_image' => 0,

			'customer_information_color'              => '',
			'customer_information_bg'                 => '',
			'customer_information_padding'            => 0,
			'customer_information_border_radius'      => 0,
			'customer_information_border_width'       => 0,
			'customer_information_border_style'       => 'solid',
			'customer_information_border_color'       => '',
			'customer_information_vertical_width'     => 0,
			'customer_information_vertical_style'     => 'dotted',
			'customer_information_vertical_color'     => '#ddd',
			'customer_information_header'             => 'Customer information',
			'customer_information_header_color'       => '',
			'customer_information_header_font_size'   => 20,
			'customer_information_header_text_align'  => 'left',
			'customer_information_billing_title'      => 'Billing address',
			'customer_information_shipping_title'     => 'Shipping address',
			'customer_information_address_color'      => '',
			'customer_information_address_bg_color'   => '',
			'customer_information_address_font_size'  => 16,
			'customer_information_address_text_align' => 'left',

			'social_icons_header'           => 'Let\'s keep in touch',
			'social_icons_header_color'     => '',
			'social_icons_header_font_size' => 18,
			'social_icons_align'            => 'left',
			'social_icons_space'            => 5,
			'social_icons_size'             => 40,
			'social_icons_target'           => '_blank',
			'social_icons_tiktok_url'       => '',
			'social_icons_tiktok_select'    => 'wtyp_social_icons-tiktok',
			'social_icons_tiktok_color'     => '#50575e',
			'social_icons_facebook_url'     => '',
			'social_icons_facebook_select'  => 'wtyp_social_icons-facebook-app-logo',
			'social_icons_facebook_color'   => '#3b579d',
			'social_icons_twitter_url'      => '',
			'social_icons_twitter_select'   => 'wtyp_social_icons-twitter-1',
			'social_icons_twitter_color'    => '#3CF',
			'social_icons_pinterest_url'    => '',
			'social_icons_pinterest_select' => 'wtyp_social_icons-pinterest-social-logo',
			'social_icons_pinterest_color'  => '#BD081C',
			'social_icons_instagram_url'    => '',
			'social_icons_instagram_select' => 'wtyp_social_icons-instagram',
			'social_icons_instagram_color'  => '#6a453b',
			'social_icons_dribbble_url'     => '',
			'social_icons_dribbble_select'  => 'wtyp_social_icons-dribbble-logo-1',
			'social_icons_dribbble_color'   => '#F26798',
			'social_icons_tumblr_url'       => '',
			'social_icons_tumblr_select'    => 'wtyp_social_icons-tumblr-logo-2',
			'social_icons_tumblr_color'     => '#32506d',
			'social_icons_google_url'       => '',
			'social_icons_google_select'    => 'wtyp_social_icons-google-plus-social-logotype-1',
			'social_icons_google_color'     => '#DC4A38',
			'social_icons_vkontakte_url'    => '',
			'social_icons_vkontakte_select' => 'wtyp_social_icons-vk-social-logotype-1',
			'social_icons_vkontakte_color'  => '#45668e',
			'social_icons_linkedin_url'     => '',
			'social_icons_linkedin_select'  => 'wtyp_social_icons-linkedin-logo-1',
			'social_icons_linkedin_color'   => '#007bb5',
			'social_icons_youtube_url'      => '',
			'social_icons_youtube_select'   => 'wtyp_social_icons-youtube-logotype',
			'social_icons_youtube_color'    => '#ff0000',

			'recently_viewed_products_limit'   => 4,
			'recently_viewed_products_columns' => 4,
			'featured_products_limit'          => 4,
			'featured_products_columns'        => 4,
			'related_products_limit'           => 4,
			'related_products_columns'         => 4,
			'best_selling_products_limit'      => 4,
			'best_selling_products_columns'    => 4,
			'sale_products_limit'              => 4,
			'sale_products_columns'            => 4,
			'recent_products_limit'            => 4,
			'recent_products_columns'          => 4,
			'top_rated_products_limit'         => 4,
			'top_rated_products_columns'       => 4,
			'up_sells_products_limit'          => 4,
			'up_sells_products_columns'        => 4,
			'cross_sells_products_limit'       => 4,
			'cross_sells_products_columns'     => 4,
			'same_category_limit'              => 4,
			'same_category_columns'            => 4,
			'specific_products_limit'          => 4,
			'specific_products_columns'        => 4,

			'thank_you_message_padding'           => '',
			'thank_you_message_color'             => '',
			'thank_you_message_text_align'        => 'left',
			'thank_you_message_header'            => 'Order #{order_number}',
			'thank_you_message_header_font_size'  => '16',
			'thank_you_message_message'           => 'Thank you {billing_first_name}',
			'thank_you_message_message_font_size' => '20',

			'google_map_api'          => '',
			'google_map_width'        => 0,
			'google_map_height'       => '500',
			'google_map_address'      => '{store_address}',
			'google_map_label'        => '<h3>This is my store</h3>
{address}',
			'google_map_zoom_level'   => 16,
			'google_map_style'        => 'default',
			'google_map_custom_style' => '',
			'google_map_marker'       => 'default',

			'coupon_text_align'        => 'center',
			'coupon_text_padding'      => 40,
			'coupon_message'           => 'You have unlocked a {coupon_amount} coupon code',
			'coupon_message_color'     => '',
			'coupon_message_font_size' => '18',
			'coupon_code_color'        => '#000000',
			'coupon_code_bg_color'     => '#efefef',
			'coupon_code_border_width' => 1,
			'coupon_code_border_style' => 'dashed',
			'coupon_code_border_color' => '#160000',
			'coupon_scissors_color'    => '#000000',

			'coupon_type'                               => array( 'unique' ),
			'existing_coupon'                           => array( '' ),
			'coupon_unique_discount_type'               => array( 'percent' ),
			'coupon_unique_amount'                      => array( '10' ),
			'coupon_unique_date_expires'                => array( 30 ),
			'coupon_unique_individual_use'              => array( false ),
			'coupon_unique_product_ids'                 => array( array() ),
			'coupon_unique_excluded_product_ids'        => array( array() ),
			'coupon_unique_usage_limit'                 => array( 1 ),
			'coupon_unique_usage_limit_per_user'        => array( 1 ),
			'coupon_unique_limit_usage_to_x_items'      => array( 1 ),
			'coupon_unique_free_shipping'               => array( false ),
			'coupon_unique_product_categories'          => array( array() ),
			'coupon_unique_excluded_product_categories' => array( array() ),
			'coupon_unique_exclude_sale_items'          => array( false ),
			'coupon_unique_minimum_amount'              => array( '' ),
			'coupon_unique_maximum_amount'              => array( '' ),
			'coupon_unique_email_restrictions'          => array( true ),
			'coupon_unique_prefix'                      => array( '' ),
			'coupon_rule_product_ids'                   => array( array() ),
			'coupon_rule_excluded_product_ids'          => array( array() ),
			'coupon_rule_product_categories'            => array( array() ),
			'coupon_rule_excluded_product_categories'   => array( array() ),
			'coupon_rule_min_total'                     => array( 0 ),
			'coupon_rule_max_total'                     => array( 0 ),
			'coupon_limit_per_day'                      => 1,
			'coupon_limit_per_week'                     => '',
			'coupon_limit_per_month'                    => '',
			'coupon_limit_per_year'                     => '',

			'custom_css' => '',

			'shortcode_products_product_ids'                 => '',
			'shortcode_products_excluded_product_ids'        => '',
			'shortcode_products_product_categories'          => '',
			'shortcode_products_excluded_product_categories' => '',
			'shortcode_products_order_by'                    => 'title',
			'shortcode_products_visibility'                  => 'visible',

			'specific_products_product_ids'                 => '',
			'specific_products_excluded_product_ids'        => '',
			'specific_products_product_categories'          => '',
			'specific_products_excluded_product_categories' => '',
			'specific_products_order_by'                    => 'title',
			'specific_products_visibility'                  => 'visible',

			'email_template'          => '',
			'coupon_email_send'       => '',
			'coupon_email_enable'     => '',
			'coupon_email_subject'    => 'Your coupon from {shop_title}',
			'coupon_email_heading'    => '{coupon_amount} OFF coupon for you',
			'coupon_email_content'    => 'Hello {billing_first_name},

Thank you for your purchase, this coupon is for you {coupon_code}. Please apply it the next time you shop with us.

We look forward to seeing you again. Have a great day!

{coupon_code_style_1}

&nbsp;

Best Regards',
			//new option 1.0.5
			'coupon_woo_email_enable' => '',
			'coupon_woo_email_status' => array(
				'customer_completed_order',
				'customer_note',
				'customer_processing_order',
			),
			'bing_map_api'            => '',
			'bing_map_width'          => 0,
			'bing_map_height'         => '500',
			'bing_map_address'        => '{store_address}',
			'bing_map_label'          => '<h3>This is my store</h3>
{address}',
			'bing_map_zoom_level'     => 14,
			'bing_map_view'           => 'road',
			'bing_map_navbarmode'     => 'default',
			'bing_map_marker'         => 'default',

			'my_account_coupon_enable' => '1',
		);

		$this->params = apply_filters( 'woo_thank_you_page_params', wp_parse_args( $woo_thank_you_page_settings, $this->default ) );
	}

	public function get_params( $name = "", $language = '', $select_template = '' ) {
		if ( ! $name ) {
			return $this->params;
		}
		$name_t = $name . $language;
		if ( $select_template !== '' ) {
			return apply_filters( 'woo_thank_you_page_params' . $name_t, $this->params[ $select_template ][ $name_t ] ?? $this->default[ $name ] ?? false );
		}

		return apply_filters( 'woo_thank_you_page_params' . $name_t, $this->params[ $name_t ] ?? $this->params[ $name ] ?? false );
	}

	public function get_default( $name = "" ) {
		if ( ! $name ) {
			return $this->default;
		} elseif ( isset( $this->default[ $name ] ) ) {
			return apply_filters( 'woo_thank_you_page_params_default' . $name, $this->default[ $name ] );
		} else {
			return false;
		}
	}

	public function set( $name ) {
		if ( is_array( $name ) ) {
			return implode( ' ', array_map( array( $this, 'set' ), $name ) );

		} else {
			return esc_attr__( $this->prefix . $name );

		}
	}

	public static function email_template_customizer_active() {
		return ( class_exists( 'WooCommerce_Email_Template_Customizer' ) || class_exists( 'Woo_Email_Template_Customizer' ) );
	}

	public static function get_email_templates( $type = 'wtypc_coupon_email' ) {
		return self::email_template_customizer_active() ? viwec_get_emails_list( $type ) : array();
	}

	public static function get_language_flag_html( $language, $languages_data = array() ) {
		if ( ! $language ) {
			return;
		}
		?>
        <p>
            <label>
				<?php
				if ( ! empty( $languages_data[ $language ]['country_flag_url'] ) ) {
					$language_country_flag_url = $languages_data[ $language ]['country_flag_url'];
					echo sprintf( '<img src="%s" > ', $language_country_flag_url );
				}
				echo esc_html( $language );
				if ( ! empty( $languages_data[ $language ]['translated_name'] ) ) {
					echo sprintf( '( %s )', $languages_data[ $language ]['translated_name'] );
				}
				?>
                :</label>
        </p>
		<?php
	}

	public static function get_templates_thank_you_page( $order_items = [] ) {
		$id_template = '0';

		if ( empty( $order_items ) ) {
			return $id_template;
		}
		$ids_product_order = [];
		foreach ( $order_items as $item_id => $item ) {
			$product_id          = $item->get_product_id();
			$ids_product_order[] = $product_id;
		}
		if ( ! empty( $ids_product_order ) ) {
			$args      = array(
				'post_type'      => 'wtyp_templates',
				'post_status'    => 'publish',
				'posts_per_page' => - 1,
				'order'          => 'DESC',
				'orderby'        => 'menu_order',
			);
			$the_query = new WP_Query( $args );

			if ( $the_query->have_posts() ) :
				while ( $the_query->have_posts() ) : $the_query->the_post();
					$wtyp_template_enable_must_include = get_post_meta( get_the_ID(), 'wtyp_template_enable_must_include', true );
					$wtyp_display_conditions           = get_post_meta( get_the_ID(), 'wtyp_template_data', true );
					$wtyp_convert_rule                 = self::wtyp_convert_rule( $wtyp_display_conditions );

					if ( $wtyp_template_enable_must_include ) {
						$check = true;
						foreach ( $ids_product_order as $order_item_id ) {
							if ( !in_array( $order_item_id, $wtyp_convert_rule ) ) {
								$check = false;
							}
						}
						if ( $check ) {
							return get_the_ID();
						}
					} else {
						foreach ( $ids_product_order as $order_item_id ) {
							if ( in_array( $order_item_id, $wtyp_convert_rule ) ) {
								return get_the_ID();
							}
						}
					}

				endwhile;
			endif;

			wp_reset_postdata();
		}

		return $id_template;
	}

	/**
	 * Function convert rule template thank you page to list of eligible products
	 *
	 * @param $wtyp_display_conditions
	 *
	 * @return array
	 */
	static public function wtyp_convert_rule( $wtyp_display_conditions ) {
		$arr_display_conditions = array(
			'include' => array(
				'product'     => array(),
				'product_cat' => array()
			),
			'exclude' => array(
				'product'     => array(),
				'product_cat' => array()
			)
		);
		if ( is_array( $wtyp_display_conditions ) ) {
			foreach ( $wtyp_display_conditions as $item_condition ) {
				if ( $item_condition['include_exclude'] == 'include' ) {
					$include_arr = $arr_display_conditions['include'];
					switch ( $item_condition['type'] ) {
						case 'product':
							if ( ! empty( $item_condition['product'] ) && is_array( $item_condition['product'] ) ) {
								$arr_display_conditions['include']['product'] = wp_parse_args( $item_condition['product'], $include_arr['product'] );
							}
							break;
						case 'product_cat':
							if ( ! empty( $item_condition['term'] ) && is_array( $item_condition['term'] ) ) {
								$arr_display_conditions['include']['product_cat'] = wp_parse_args( $item_condition['term'], $include_arr['product_cat'] );
							}
							break;
						default:
							break;
					}
				} else if ( $item_condition['include_exclude'] == 'exclude' ) {
					$exclude_arr = $arr_display_conditions['exclude'];
					switch ( $item_condition['type'] ) {
						case 'product':
							if ( ! empty( $item_condition['product'] ) && is_array( $item_condition['product'] ) ) {
								$arr_display_conditions['exclude']['product'] = wp_parse_args( $item_condition['product'], $exclude_arr['product'] );
							}
							break;
						case 'product_cat':
							if ( ! empty( $item_condition['term'] ) && is_array( $item_condition['term'] ) ) {
								$arr_display_conditions['exclude']['product_cat'] = wp_parse_args( $item_condition['term'], $exclude_arr['product_cat'] );
							}
							break;
						default:
							break;
					}
				}
			}
		}
		$args_product = array(
			'post_type'   => 'product',
			'numberposts' => - 1,
			'post_status' => 'publish',
			'fields'      => 'ids',
			'post__in'    => array( 0 ) /*Add default ids product is 0 to don't get any product (array)*/
		);
		/*Add tax query to $args_product*/
		if ( ! empty( $arr_display_conditions['include']['product_cat'] ) || ! empty( $arr_display_conditions['exclude']['product_cat'] ) ) {
			$arr_tax_query = array(
				'relation ' => 'AND'
			);
			if ( ! empty( $arr_display_conditions['include']['product_cat'] ) && is_array( $arr_display_conditions['include']['product_cat'] ) ) {
				$arr_tax_query[] = array(
					'taxonomy' => 'product_cat',
					'field'    => 'id',
					'terms'    => $arr_display_conditions['include']['product_cat'], /*category ids (array)*/
					'operator' => 'IN',
				);
			}
			if ( ! empty( $arr_display_conditions['exclude']['product_cat'] ) && is_array( $arr_display_conditions['exclude']['product_cat'] ) ) {
				$arr_tax_query[] = array(
					'taxonomy' => 'product_cat',
					'field'    => 'id',
					'terms'    => $arr_display_conditions['exclude']['product_cat'], /*category ids (array)*/
					'operator' => 'NOT IN',
				);
			}
			$args_product_by_cat_id                       = get_posts( array(
				'post_type'   => 'product',
				'numberposts' => - 1,
				'post_status' => 'publish',
				'fields'      => 'ids',
				'tax_query'   => $arr_tax_query
			) );
			$arr_display_conditions['include']['product'] = wp_parse_args( $args_product_by_cat_id, $arr_display_conditions['include']['product'] );
		}
		/*Add ids product to $args_product*/

		if (
			! empty( $arr_display_conditions['exclude']['product'] ) &&
			is_array( $arr_display_conditions['exclude']['product'] ) &&
			! empty( $arr_display_conditions['include']['product'] ) &&
			is_array( $arr_display_conditions['include']['product'] )
		) {
			$arr_display_conditions['include']['product'] = array_diff( $arr_display_conditions['include']['product'], $arr_display_conditions['exclude']['product'] );

		}
		if ( ! empty( $arr_display_conditions['include']['product'] ) && is_array( $arr_display_conditions['include']['product'] ) ) {
			$args_product['post__in'] = $arr_display_conditions['include']['product'];
		}


		$arr_lists_product = get_posts( $args_product );

		return $arr_lists_product;
	}
}

new VI_WOOCOMMERCE_THANK_YOU_PAGE_DATA();
