jQuery(document).ready(function ($) {
    'use strict';

    $('.vi-ui.dropdown').dropdown().trigger('change');

    handleDropdownSelect();

    function handleDropdownSelect() {
        $('.wtyp-display_conditions_archive select').on('change', function () {
            let val = $(this).val();
            let option_product_id = $(this).closest('.condition_item').find('.option_product_id');
            let option_term_id = $(this).closest('.condition_item').find('.option_term_id');

            option_product_id.addClass('hidden');
            option_term_id.addClass('hidden');

            switch (val) {
                case 'product':

                    option_product_id.removeClass('hidden');
                    break;
                case 'product_cat':

                    option_term_id.removeClass('hidden');
                    break;
                default:
            }

        }).trigger('change');

    }

    _load_select2($(".wtyp-display_conditions_product_id"), 'product');
    _load_select2($(".wtyp-display_conditions_term_id"));

    function _load_select2(selector, type) {
        let function_name, placeholder;
        if (type === 'product') {
            function_name = 'wtyp_search_product';
            placeholder = "Please fill in your product title";
        } else {
            function_name = 'wtyp_search_cate';
            placeholder = "Please fill in your category title";
        }
        selector.select2({
            minimumInputLength: 1,
            closeOnSelect: false,
            scrollAfterSelect: false,
            placeholder: placeholder,
            ajax: {
                url: "admin-ajax.php?action=" + function_name,
                dataType: 'json',
                type: "GET",
                quietMillis: 50,
                delay: 250,
                data: function (params) {
                    return {
                        keyword: params.term
                    };
                },
                processResults: function (data) {
                    return {
                        results: data
                    };
                },
                cache: true
            },
            escapeMarkup: function (markup) {
                return markup;
            }, // let our custom formatter work

        });
    }

    $(document).on('click', '.add_row_condition', function () {
        let conditions_list = $('#conditions_list');
        let $this_clone = $(`
            <div class="conditions_wrap" id="conditions_list">
                <div class="vi-ui field condition_item">
                    <div class="item_column type">
                        <select class="vi-ui dropdown fluid wtyp_template_select wtyp-display_conditions_type" name="wtyp_display_conditions[0][include_exclude]">
                            <option value="include">INCLUDE</option>
                            <option value="exclude">EXCLUDE</option>
                        </select>
                    </div>
                    <div class="item_column archive">
                       
                        <select class="vi-ui dropdown fluid wtyp_template_select wtyp-display_conditions_archive" name="wtyp_display_conditions[0][type]">
                            <option value="product">Products</option>
                            <option value="product_cat">Product Categories</option>
                        </select>
                    </div>
                    <div class="item_column option_product_id " data-type_show="product">
                        <select class="wtyp-display_conditions_product_id" name="wtyp_display_conditions[0][product][]" multiple="" ></select>
                        </div>
                    <div class="item_column option_term_id hidden" data-type_show="product_cat">
                        <select class="wtyp-display_conditions_term_id" name="wtyp_display_conditions[0][term][]" multiple=""></select>
                        </div>
                    <div class="item_column action_btn">
                        <div class="wrap_add_del_btn">
                            <a href="#" class="vi-ui add_row_condition icon green button mini compact"> <i class="plus icon"></i></a>
                            <a href="#" class="vi-ui del_row_condition icon red button mini compact"> <i class="minus icon"></i></a>
                        </div>
                    </div>
                </div>
            </div>
        `);

        _load_select2($this_clone.find('.wtyp-display_conditions_product_id'), 'product');
        _load_select2($this_clone.find('.wtyp-display_conditions_term_id'), 'product_cats');

        conditions_list.append($this_clone);
        _load_name_row_duplicate(conditions_list);
        $('.vi-ui.dropdown').dropdown();
        handleDropdownSelect();
        return false;
    });

    $(document).on('click', '.del_row_condition', function () {
        let $this = $(this),
            $this_val = $(this).val(),
            $this_closet = $this.closest('.condition_item');
        if (
            $('#conditions_list .condition_item').length > 1
        ) {
            $this_closet.remove();
            _load_name_row_duplicate($('#conditions_list'));
        } else {
            alert('Unable to delete row');
        }
        return false;
    });

    function _load_name_row_duplicate(seletor) {
        let _this_wrap_loop = seletor.find('.condition_item');

        let i = 0;
        _this_wrap_loop.each(function () {
            $(this).find('.wtyp-display_conditions_type').attr('name', 'wtyp_display_conditions[' + i + '][include_exclude]');
            $(this).find('.wtyp-display_conditions_archive').attr('name', 'wtyp_display_conditions[' + i + '][type]');
            $(this).find('.wtyp-display_conditions_product_id ').attr('name', 'wtyp_display_conditions[' + i + '][product][]');
            $(this).find('.wtyp-display_conditions_term_id').attr('name', 'wtyp_display_conditions[' + i + '][term][]');
            i++;
        });
    }


});